/*
 * PostgreSQL functions to interface with memcached using libmemcached.
 *
 * Copyright (c) 2004-2005 Sean Chittenden <sean@chittenden.org>
 * Copyright (c) 2007 Neil Conway <neilc@samurai.com>
 * Copyright (c) 2007 Open Technology Group, Inc. <http://www.otg-nc.com>
 * Copyright (c) 2008-2009 Suzuki Hironobu <hironobu@interdb.jp>
 *
 * See the file COPYING for distribution terms.
 */
#ifndef PGMEMCACHED_H
#define PGMEMCACHED_H

#include "libmemcached/memcached.h"


void _PG_init(void);
void _PG_fini(void);

Datum pgmemcached_add(PG_FUNCTION_ARGS);
Datum pgmemcached_add_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_append(PG_FUNCTION_ARGS);
Datum pgmemcached_append_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_behavior_get(PG_FUNCTION_ARGS);
Datum pgmemcached_behavior_set1(PG_FUNCTION_ARGS);
Datum pgmemcached_behavior_set2(PG_FUNCTION_ARGS);
Datum pgmemcached_create(PG_FUNCTION_ARGS);
Datum pgmemcached_decr(PG_FUNCTION_ARGS);
Datum pgmemcached_delete(PG_FUNCTION_ARGS);
Datum pgmemcached_delete_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_flush(PG_FUNCTION_ARGS);
Datum pgmemcached_free(PG_FUNCTION_ARGS);
Datum pgmemcached_get(PG_FUNCTION_ARGS);
Datum pgmemcached_get_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_hash(PG_FUNCTION_ARGS);
Datum pgmemcached_incr(PG_FUNCTION_ARGS);
Datum pgmemcached_prepend(PG_FUNCTION_ARGS);
Datum pgmemcached_prepend_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_quit(PG_FUNCTION_ARGS);
Datum pgmemcached_replace(PG_FUNCTION_ARGS);
Datum pgmemcached_replace_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_return(PG_FUNCTION_ARGS);
Datum pgmemcached_server_add(PG_FUNCTION_ARGS);
Datum pgmemcached_server_count(PG_FUNCTION_ARGS);
Datum pgmemcached_server_display(PG_FUNCTION_ARGS);
Datum pgmemcached_server_find(PG_FUNCTION_ARGS);
Datum pgmemcached_server_find_hash(PG_FUNCTION_ARGS);
Datum pgmemcached_server_list(PG_FUNCTION_ARGS);
Datum pgmemcached_server_list_append(PG_FUNCTION_ARGS);
Datum pgmemcached_server_list_count(PG_FUNCTION_ARGS);
Datum pgmemcached_server_list_free(PG_FUNCTION_ARGS);
Datum pgmemcached_server_push(PG_FUNCTION_ARGS);
Datum pgmemcached_server_remove(PG_FUNCTION_ARGS);
Datum pgmemcached_set(PG_FUNCTION_ARGS);
Datum pgmemcached_set_by_key(PG_FUNCTION_ARGS);
Datum pgmemcached_stat(PG_FUNCTION_ARGS);
Datum pgmemcached_stat_get_value(PG_FUNCTION_ARGS);
Datum pgmemcached_strerror(PG_FUNCTION_ARGS);

PG_FUNCTION_INFO_V1(pgmemcached_add);
PG_FUNCTION_INFO_V1(pgmemcached_add_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_append);
PG_FUNCTION_INFO_V1(pgmemcached_append_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_behavior_get);
PG_FUNCTION_INFO_V1(pgmemcached_behavior_set1);
PG_FUNCTION_INFO_V1(pgmemcached_behavior_set2);
PG_FUNCTION_INFO_V1(pgmemcached_create);
PG_FUNCTION_INFO_V1(pgmemcached_decr);
PG_FUNCTION_INFO_V1(pgmemcached_delete);
PG_FUNCTION_INFO_V1(pgmemcached_delete_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_flush);
PG_FUNCTION_INFO_V1(pgmemcached_free);
PG_FUNCTION_INFO_V1(pgmemcached_get);
PG_FUNCTION_INFO_V1(pgmemcached_get_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_hash);
PG_FUNCTION_INFO_V1(pgmemcached_incr);
PG_FUNCTION_INFO_V1(pgmemcached_prepend);
PG_FUNCTION_INFO_V1(pgmemcached_prepend_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_quit);
PG_FUNCTION_INFO_V1(pgmemcached_replace);
PG_FUNCTION_INFO_V1(pgmemcached_replace_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_return);
PG_FUNCTION_INFO_V1(pgmemcached_server_add);
PG_FUNCTION_INFO_V1(pgmemcached_server_count);
PG_FUNCTION_INFO_V1(pgmemcached_server_display);
PG_FUNCTION_INFO_V1(pgmemcached_server_find);
PG_FUNCTION_INFO_V1(pgmemcached_server_find_hash);
PG_FUNCTION_INFO_V1(pgmemcached_server_list);
PG_FUNCTION_INFO_V1(pgmemcached_server_list_append);
PG_FUNCTION_INFO_V1(pgmemcached_server_list_count);
PG_FUNCTION_INFO_V1(pgmemcached_server_list_free);
PG_FUNCTION_INFO_V1(pgmemcached_server_push);
PG_FUNCTION_INFO_V1(pgmemcached_server_remove);
PG_FUNCTION_INFO_V1(pgmemcached_set);
PG_FUNCTION_INFO_V1(pgmemcached_set_by_key);
PG_FUNCTION_INFO_V1(pgmemcached_stat);
PG_FUNCTION_INFO_V1(pgmemcached_stat_get_value);
PG_FUNCTION_INFO_V1(pgmemcached_strerror);

#endif
